require "js_responder/version"

class JsResponder
  attr_accessor :instructions

  def initialize
    @instructions = []
  end

  def transcode(context=nil, &block)
    if block_given?
      instance_exec(context, &block)
    else
      raise 'Expecting a block'
    end
    return instructions
  end

  # Default instruction set
  def redirect(url)
    instructions << ['redirect', url]
  end

  def log(text)
    instructions << ['log', text]
  end

  def success(text)
    instructions << ['success', text]
  end

  def error(text)
    instructions << ['error', text]
  end

  # Introduce some flexibility by catching other commands
  def method_missing(method, *args)
    instructions << [[method.to_s], args].flatten!
  end

end
